//+------------------------------------------------------------------+
//|                                                        2_RSI_DIFF.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window

#property indicator_buffers 1



extern bool Use_SYMBOL = false;
extern string SYMBOL = "EURUSD";

extern bool Use_War = true;

extern color Color_RSI=DodgerBlue;
extern color Color_TAB = White;
extern color Color_UP=LimeGreen;
extern color Color_DOWN=Red;
extern color Color_RSI_MTF=DodgerBlue;

extern color war1=Orange;
extern color war2=Green;

color col;

extern int RSI_Period = 14;
extern int Price = 0;
extern int Hist =1000;

extern int limit_UP =70;
extern int limit_DOWN = 30;
extern int war = 5;

extern bool Use_Left_Corner = false;
extern bool Use_Mirroring = false;
extern bool Show_in_Win = false;
extern int pos_X=0;
extern int pos_Y=0;
double RSI_C[];
double pos,W,Z,RSI;

/*
string   periodString[]     = {"1","5","15","30","H","4","D","W","M"};
int      period[]           = {1,5,15,30,60,240,1440,10080,43200};
*/
string   periodString2[]     = {"M","W","D","4","H","30","15","5","1"};
int      period2[]           = {43200,10080,1440,240,60,30,15,5,1};

string   periodString3[];
int      period3[];

string short_name,RSIval,SYM;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

//----
   int init()
  {
  
  if(Use_SYMBOL )SYM = SYMBOL; else SYM = Symbol();
 
         short_name="RSI("+RSI_Period+")"+SYM;
         
     IndicatorShortName(short_name);
     IndicatorBuffers(1);

 
     SetIndexStyle(0,DRAW_LINE,0,0,Color_RSI);  
      
  
     SetIndexLabel (0, "RSI");
       
 SetIndexBuffer(0, RSI_C);
 
 
 
 
       
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
  
  
//----
 if (StringSubstr(Symbol(),3,3) == "JPY")pos = -1 ;else pos = -3;
int y;
 for (int x=0; x<9; x++)   {
 
 
 //if (Use_Mirroring)  {periodString3[x]=periodString2[x];period3[x]=period2[x]  ; } else {periodString3[x]=periodString[x];period3[x]=period[x]  ; }
  
    
   y=y+40;
   
  RSI = iRSI(Symbol(),period2[x],RSI_Period,0,0) ;
    
    RSIval = DoubleToStr(RSI,Digits+pos) ;
     
    
   if (Use_War)
 {  
   if (RSI>limit_UP-war) col = war2;
   if (RSI<limit_DOWN+war) col = war1;
   
   if (RSI>limit_DOWN+war&&RSI<limit_UP-war) col = Color_RSI_MTF;
    if (RSI>limit_UP) col = Color_UP;
   if (RSI<limit_DOWN) col = Color_DOWN;
    }
   else 
  { 
 if (RSI>limit_UP) col = Color_UP;
   if (RSI<limit_DOWN) col = Color_DOWN;
   
   if (RSI>limit_DOWN&&RSI<limit_UP) col = Color_RSI_MTF;

  }
     if (Show_in_Win) W= WindowFind (short_name); else W=0;
       if (Use_Left_Corner) Z= 0 ; else Z=1;
       
        
         ObjectCreate(short_name+""+x+"", OBJ_LABEL,W, 0, 0);
   ObjectSetText(short_name+""+x+"",""+RSIval+"", 9, "Arial", col);
   ObjectSet(short_name+""+x+"", OBJPROP_CORNER, Z);
   ObjectSet(short_name+""+x+"", OBJPROP_XDISTANCE, 0+y+pos_X);
   ObjectSet(short_name+""+x+"", OBJPROP_YDISTANCE, 30+pos_Y);   
   
    
         ObjectCreate(short_name+""+x+0.1+"", OBJ_LABEL,W, 0, 0);
   ObjectSetText(short_name+""+x+0.1+"",""+periodString2[x]+"", 9, "Arial", Color_TAB);
   ObjectSet(short_name+""+x+0.1+"", OBJPROP_CORNER, Z);
   ObjectSet(short_name+""+x+0.1+"", OBJPROP_XDISTANCE, 10+y+pos_X);
   ObjectSet(short_name+""+x+0.1+"", OBJPROP_YDISTANCE, 15+pos_Y);   
   
   
   
}
   int i, limit, counted_bars=IndicatorCounted();   
   
  if(counted_bars < 0) 
      return(-1);
   if(counted_bars > 0) 
      counted_bars--;
   
   limit = Bars - counted_bars;
   
   if(Hist >= 0) 
      limit = Hist;

   for (i = limit; i>=0; i--)
   {  
       
        
         RSI_C[i]=iRSI(SYM,0,RSI_Period,Price,i);
      

 }  
  
//----
   return(0);
  }
//+------------------------------------------------------------------+